<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>My Project: BLEClient.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">My Project
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">BLEClient.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * BLEDevice.h</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> *  Created on: Mar 22, 2017</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> *      Author: kolban</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;</div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#ifndef MAIN_BLEDEVICE_H_</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#define MAIN_BLEDEVICE_H_</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;</div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">#include &quot;sdkconfig.h&quot;</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="preprocessor">#if defined(CONFIG_BT_ENABLED)</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;</div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="preprocessor">#include &lt;esp_gattc_api.h&gt;</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="preprocessor">#include &lt;string.h&gt;</span></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#include &lt;map&gt;</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="preprocessor">#include &lt;string&gt;</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="preprocessor">#include &quot;BLEExceptions.h&quot;</span></div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="preprocessor">#include &quot;BLERemoteService.h&quot;</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="preprocessor">#include &quot;BLEService.h&quot;</span></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="preprocessor">#include &quot;BLEAddress.h&quot;</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="preprocessor">#include &quot;BLEAdvertisedDevice.h&quot;</span></div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;</div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="keyword">class </span>BLERemoteService;</div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="keyword">class </span>BLEClientCallbacks;</div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="keyword">class </span>BLEAdvertisedDevice;</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="keyword">class </span>BLEClient {</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;    BLEClient();</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;    ~BLEClient();</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;    <span class="keywordtype">bool</span>                                       connect(BLEAdvertisedDevice* device);</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;    <span class="keywordtype">bool</span>                                       connect(BLEAddress address, esp_ble_addr_type_t type = BLE_ADDR_TYPE_PUBLIC);   <span class="comment">// Connect to the remote BLE Server</span></div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;    <span class="keywordtype">void</span>                                       disconnect();                  <span class="comment">// Disconnect from the remote BLE Server</span></div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;    BLEAddress                                 getPeerAddress();              <span class="comment">// Get the address of the remote BLE Server</span></div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;    <span class="keywordtype">int</span>                                        getRssi();                     <span class="comment">// Get the RSSI of the remote BLE Server</span></div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;    std::map&lt;std::string, BLERemoteService*&gt;*  getServices();                 <span class="comment">// Get a map of the services offered by the remote BLE Server</span></div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;    BLERemoteService*                          getService(<span class="keyword">const</span> <span class="keywordtype">char</span>* uuid);  <span class="comment">// Get a reference to a specified service offered by the remote BLE server.</span></div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;    BLERemoteService*                          getService(BLEUUID uuid);      <span class="comment">// Get a reference to a specified service offered by the remote BLE server.</span></div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;    std::string                                getValue(BLEUUID serviceUUID, BLEUUID characteristicUUID);   <span class="comment">// Get the value of a given characteristic at a given service.</span></div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;    <span class="keywordtype">void</span>                                       handleGAPEvent(</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;                                                    esp_gap_ble_cb_event_t  event,</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;                                                esp_ble_gap_cb_param_t* param);</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;    <span class="keywordtype">bool</span>                                       isConnected();                 <span class="comment">// Return true if we are connected.</span></div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;    <span class="keywordtype">void</span>                                       setClientCallbacks(BLEClientCallbacks *pClientCallbacks, <span class="keywordtype">bool</span> deleteCallbacks = <span class="keyword">true</span>);</div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;    <span class="keywordtype">void</span>                                       setValue(BLEUUID serviceUUID, BLEUUID characteristicUUID, std::string value);   <span class="comment">// Set the value of a given characteristic at a given service.</span></div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;    std::string                                toString();                    <span class="comment">// Return a string representation of this client.</span></div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;    uint16_t                                   getConnId();</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;    esp_gatt_if_t                              getGattcIf();</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;    uint16_t                                   getMTU();</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;uint16_t m_appId;</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;    <span class="keyword">friend</span> <span class="keyword">class </span>BLEDevice;</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;    <span class="keyword">friend</span> <span class="keyword">class </span>BLERemoteService;</div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;    <span class="keyword">friend</span> <span class="keyword">class </span>BLERemoteCharacteristic;</div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;    <span class="keyword">friend</span> <span class="keyword">class </span>BLERemoteDescriptor;</div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;    <span class="keywordtype">void</span> gattClientEventHandler(esp_gattc_cb_event_t event, esp_gatt_if_t gattc_if, esp_ble_gattc_cb_param_t* param);</div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;    BLEAddress    m_peerAddress = BLEAddress((uint8_t*)<span class="stringliteral">&quot;\0\0\0\0\0\0&quot;</span>);   <span class="comment">// The BD address of the remote server.</span></div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;    uint16_t      m_conn_id;</div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;    esp_gatt_if_t m_gattc_if;</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;    <span class="keywordtype">bool</span>          m_haveServices = <span class="keyword">false</span>;    <span class="comment">// Have we previously obtain the set of services from the remote server.</span></div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;    <span class="keywordtype">bool</span>          m_isConnected = <span class="keyword">false</span>;     <span class="comment">// Are we currently connected.</span></div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;    <span class="keywordtype">bool</span>          m_deleteCallbacks = <span class="keyword">true</span>;</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;</div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;    BLEClientCallbacks* m_pClientCallbacks = <span class="keyword">nullptr</span>;</div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;    <a class="code" href="classFreeRTOS_1_1Semaphore.html">FreeRTOS::Semaphore</a> m_semaphoreRegEvt        = <a class="code" href="classFreeRTOS_1_1Semaphore.html">FreeRTOS::Semaphore</a>(<span class="stringliteral">&quot;RegEvt&quot;</span>);</div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;    <a class="code" href="classFreeRTOS_1_1Semaphore.html">FreeRTOS::Semaphore</a> m_semaphoreOpenEvt       = <a class="code" href="classFreeRTOS_1_1Semaphore.html">FreeRTOS::Semaphore</a>(<span class="stringliteral">&quot;OpenEvt&quot;</span>);</div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;    <a class="code" href="classFreeRTOS_1_1Semaphore.html">FreeRTOS::Semaphore</a> m_semaphoreSearchCmplEvt = <a class="code" href="classFreeRTOS_1_1Semaphore.html">FreeRTOS::Semaphore</a>(<span class="stringliteral">&quot;SearchCmplEvt&quot;</span>);</div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;    <a class="code" href="classFreeRTOS_1_1Semaphore.html">FreeRTOS::Semaphore</a> m_semaphoreRssiCmplEvt   = <a class="code" href="classFreeRTOS_1_1Semaphore.html">FreeRTOS::Semaphore</a>(<span class="stringliteral">&quot;RssiCmplEvt&quot;</span>);</div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;    std::map&lt;std::string, BLERemoteService*&gt; m_servicesMap;</div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;    std::map&lt;BLERemoteService*, uint16_t&gt; m_servicesMapByInstID;</div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;    <span class="keywordtype">void</span> clearServices();   <span class="comment">// Clear any existing services.</span></div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;    uint16_t m_mtu = 23;</div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;}; <span class="comment">// class BLEDevice</span></div><div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;</div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;</div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;<span class="keyword">class </span>BLEClientCallbacks {</div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;    <span class="keyword">virtual</span> ~BLEClientCallbacks() {};</div><div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">void</span> onConnect(BLEClient *pClient) = 0;</div><div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">void</span> onDisconnect(BLEClient *pClient) = 0;</div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;};</div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;</div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;<span class="preprocessor">#endif // CONFIG_BT_ENABLED</span></div><div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* MAIN_BLEDEVICE_H_ */</span><span class="preprocessor"></span></div><div class="ttc" id="classFreeRTOS_1_1Semaphore_html"><div class="ttname"><a href="classFreeRTOS_1_1Semaphore.html">FreeRTOS::Semaphore</a></div><div class="ttdef"><b>Definition:</b> FreeRTOS.h:31</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.15
</small></address>
</body>
</html>
